package WayofTime.alchemicalWizardry.common.renderer.model;

import net.minecraft.client.model.ModelBiped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.entity.Entity;

/**
 * OmegaEarth.tcn - TechneToTabulaImporter
 * Created using Tabula 4.1.0
 */
public class ModelOmegaEarth extends ModelBiped{

    public ModelRenderer backPlate;
    public ModelRenderer topPlate;
    public ModelRenderer sidePlate6;
    public ModelRenderer sidePlate5;
    public ModelRenderer sidePlate4;
    public ModelRenderer sidePlate3;
    public ModelRenderer sidePlate2;
    public ModelRenderer sidePlate1;
    public ModelRenderer facePlate6;
    public ModelRenderer facePlate1;
    public ModelRenderer facePlate5;
    public ModelRenderer facePlate4;
    public ModelRenderer facePlate2;
    public ModelRenderer facePlate3;
    public ModelRenderer chestMain;
    public ModelRenderer backPlate_1;
    public ModelRenderer chestPlate1;
    public ModelRenderer chestPlate2;
    public ModelRenderer chestPlate3;
    public ModelRenderer chestPlate4;
    public ModelRenderer chestPlate5;
    public ModelRenderer chestPlate6;
    public ModelRenderer belt;
    public ModelRenderer rightShoulder;
    public ModelRenderer rightArm;
    public ModelRenderer rightArmSymbol;
    public ModelRenderer rightArmPlate1;
    public ModelRenderer rightArmPlate2;
    public ModelRenderer rightArmPlate3;
    public ModelRenderer rightArmPlate4;
    public ModelRenderer leftShoulder;
    public ModelRenderer leftArm;
    public ModelRenderer leftArmSymbol;
    public ModelRenderer leftArmPlate1;
    public ModelRenderer leftArmPlate2;
    public ModelRenderer leftArmPlate3;
    public ModelRenderer leftArmPlate4;
    public ModelRenderer rightLeg;
    public ModelRenderer rightLegPlate1;
    public ModelRenderer rightLegPlate2;
    public ModelRenderer rightLegPlate3;
    public ModelRenderer rightLegPlate4;
    public ModelRenderer rightLegPlate5;
    public ModelRenderer rightLegPlate6;
    public ModelRenderer rightLegPlate7;
    public ModelRenderer rightLegPlate8;
    public ModelRenderer rightLegPlate10;
    public ModelRenderer rightLegPlate9;
    public ModelRenderer rightLegPlate11;
    public ModelRenderer rightLegPlate12;
    public ModelRenderer rightLegPlate13;
    public ModelRenderer rightBoot1;
    public ModelRenderer rightBoot2;
    public ModelRenderer rightBoot3;
    public ModelRenderer leftLeg;
    public ModelRenderer leftLegPlate1;
    public ModelRenderer leftLegPlate2;
    public ModelRenderer leftLegPlate3;
    public ModelRenderer leftLegPlate4;
    public ModelRenderer leftLegPlate5;
    public ModelRenderer leftLegPlate6;
    public ModelRenderer leftLegPlate7;
    public ModelRenderer leftLegPlate8;
    public ModelRenderer leftLegPlate9;
    public ModelRenderer leftLegPlate10;
    public ModelRenderer leftLegPlate11;
    public ModelRenderer leftLegPlate12;
    public ModelRenderer leftLegPlate13;
    public ModelRenderer leftBoot1;
    public ModelRenderer leftBoot2;
    public ModelRenderer leftBoot3;

    public ModelOmegaEarth(float f, boolean addHelmet, boolean addChestPiece, boolean addLeggings, boolean addBoots)
  {
        super(f, 0.0f, 256, 128);
        this.leftShoulder = new ModelRenderer(this, 29, 33);
        this.leftShoulder.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftShoulder.addBox(-1.0F, -3.0F, -3.0F, 6, 5, 6, 0.0F);
        this.leftBoot1 = new ModelRenderer(this, 44, 61);
        this.leftBoot1.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftBoot1.addBox(-2.0F, 9.5F, -5.0F, 5, 3, 8, 0.0F);
        this.leftLegPlate9 = new ModelRenderer(this, 0, 86);
        this.leftLegPlate9.setRotationPoint(0.0F, 2.5F, 0.0F);
        this.leftLegPlate9.addBox(-2.5F, 1.5F, 1.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(leftLegPlate9, 0.40142572795869574F, -0.0F, 0.0F);
        this.facePlate3 = new ModelRenderer(this, 0, 100);
        this.facePlate3.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.facePlate3.addBox(-1.0F, -7.5F, -6.5F, 5, 4, 1, 0.0F);
        this.setRotateAngle(facePlate3, -0.17453292012214658F, -0.15707963705062866F, 0.0F);
        this.leftArm = new ModelRenderer(this, 29, 45);
        this.leftArm.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftArm.addBox(-1.0F-0.5f, 2.0F, -2.5F, 5, 9, 5, 0.0F);
        this.leftLegPlate11 = new ModelRenderer(this, 0, 91);
        this.leftLegPlate11.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftLegPlate11.addBox(1.0F, 1.5F, -2.5F, 1, 3, 5, 0.0F);
        this.setRotateAngle(leftLegPlate11, 0.0F, -0.0F, -0.40142572795869574F);
        this.leftBoot3 = new ModelRenderer(this, 45, 73);
        this.leftBoot3.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftBoot3.addBox(0.0F, 9.0F, -4.5F, 1, 3, 7, 0.0F);
        this.setRotateAngle(leftBoot3, 0.10471975511965977F, -0.0F, -0.2617993877991494F);
        this.leftLegPlate5 = new ModelRenderer(this, 13, 86);
        this.leftLegPlate5.setRotationPoint(0.0F, 5.0F, 0.0F);
        this.leftLegPlate5.addBox(-2.5F, 1.5F, -2.8F, 3, 2, 1, 0.0F);
        this.setRotateAngle(leftLegPlate5, -0.40142572795869574F, -0.0F, 0.0F);
        this.leftArmPlate1 = new ModelRenderer(this, 0, 56);
        this.leftArmPlate1.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftArmPlate1.addBox(-2.0F, -5.0F, -4.5F, 6, 3, 1, 0.0F);
        this.setRotateAngle(leftArmPlate1, -0.19198621771937624F, -0.0F, 0.9599310885968813F);
        this.rightLegPlate13 = new ModelRenderer(this, 0, 91);
        this.rightLegPlate13.mirror = true;
        this.rightLegPlate13.setRotationPoint(0.0F, 5.0F, 0.0F);
        this.rightLegPlate13.addBox(-2.0F, 1.5F, -2.5F, 1, 3, 5, 0.0F);
        this.setRotateAngle(rightLegPlate13, 0.0F, -0.0F, 0.40142572795869574F);
        this.rightLegPlate2 = new ModelRenderer(this, 0, 86);
        this.rightLegPlate2.mirror = true;
        this.rightLegPlate2.setRotationPoint(0.0F, 2.5F, 0.0F);
        this.rightLegPlate2.addBox(-2.5F, 1.5F, -2.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(rightLegPlate2, -0.40142572795869574F, -0.0F, 0.0F);
        this.rightLegPlate8 = new ModelRenderer(this, 0, 86);
        this.rightLegPlate8.mirror = true;
        this.rightLegPlate8.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightLegPlate8.addBox(-2.5F, 1.5F, 1.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(rightLegPlate8, 0.40142572795869574F, -0.0F, 0.0F);
        this.rightLegPlate1 = new ModelRenderer(this, 0, 86);
        this.rightLegPlate1.mirror = true;
        this.rightLegPlate1.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightLegPlate1.addBox(-2.5F, 1.5F, -2.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(rightLegPlate1, -0.40142572795869574F, -0.0F, 0.0F);
        this.rightLegPlate7 = new ModelRenderer(this, 13, 90);
        this.rightLegPlate7.mirror = true;
        this.rightLegPlate7.setRotationPoint(0.0F, 5.0F, 0.0F);
        this.rightLegPlate7.addBox(-1.5F, 1.0F, -2.8F, 1, 2, 1, 0.0F);
        this.setRotateAngle(rightLegPlate7, -0.40142572795869574F, -0.0F, 0.0F);
        this.chestPlate6 = new ModelRenderer(this, 0, 52);
        this.chestPlate6.mirror = true;
        this.chestPlate6.setRotationPoint(0.0F, -3.5F, 0.0F);
        this.chestPlate6.addBox(-5.5F, 2.0F, -4.5F, 5, 2, 1, 0.0F);
        this.setRotateAngle(chestPlate6, 0.3141592741012573F, -0.0F, -0.12217304855585097F);

        this.sidePlate5 = new ModelRenderer(this, 13, 110);
        this.sidePlate5.setRotationPoint(0.0F, 0.5F, 3.0F);
        this.sidePlate5.addBox(4.0F, -8.5F, -4.0F, 1, 7, 4, 0.0F);
        this.setRotateAngle(sidePlate5, 0.0F, 0.22689279913902283F, 0.0F);

        this.chestMain = new ModelRenderer(this, 0, 33);
        this.chestMain.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.chestMain.addBox(-4.5F, -0.009999999776482582F, -2.5F, 9, 13, 5, 0.0F);
        this.facePlate2 = new ModelRenderer(this, 0, 110);
        this.facePlate2.mirror = true;
        this.facePlate2.setRotationPoint(0.0F, 0.5F, 0.0F);
        this.facePlate2.addBox(-3.0F, -3.5F, -5.5F, 5, 3, 1, 0.0F);
        this.setRotateAngle(facePlate2, 0.05235987901687623F, 0.34906584024429316F, 0.0F);
        this.rightArm = new ModelRenderer(this, 29, 45);
        this.rightArm.mirror = true;
        this.rightArm.setRotationPoint(0.0F+0.5f, 0.0F, 0.0F);
        this.rightArm.addBox(-4.0F, 2.0F, -2.5F, 5, 9, 5, 0.0F);

        this.rightLegPlate11 = new ModelRenderer(this, 0, 91);
        this.rightLegPlate11.mirror = true;
        this.rightLegPlate11.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightLegPlate11.addBox(-2.0F, 1.5F, -2.5F, 1, 3, 5, 0.0F);
        this.setRotateAngle(rightLegPlate11, 0.0F, -0.0F, 0.40142572795869574F);
        this.leftLegPlate3 = new ModelRenderer(this, 0, 86);
        this.leftLegPlate3.setRotationPoint(0.0F, 5.0F, 0.0F);
        this.leftLegPlate3.addBox(-2.5F, 1.5F, -2.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(leftLegPlate3, -0.40142572795869574F, -0.0F, 0.0F);
        this.rightArmPlate4 = new ModelRenderer(this, 0, 56);
        this.rightArmPlate4.mirror = true;
        this.rightArmPlate4.setRotationPoint(-0.0F, 0.0F, 0.0F);
        this.rightArmPlate4.addBox(-4.0F, -3.0F, 3.0F, 6, 3, 1, 0.0F);
        this.setRotateAngle(rightArmPlate4, 0.19198621771937624F, -0.0F, -0.9599310885968813F);
        this.rightLegPlate10 = new ModelRenderer(this, 0, 86);
        this.rightLegPlate10.mirror = true;
        this.rightLegPlate10.setRotationPoint(0.0F, 5.0F, 0.0F);
        this.rightLegPlate10.addBox(-2.5F, 1.5F, 1.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(rightLegPlate10, 0.40142572795869574F, -0.0F, 0.0F);
        this.rightArmSymbol = new ModelRenderer(this, 50, 45);
        this.rightArmSymbol.mirror = true;
        this.rightArmSymbol.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightArmSymbol.addBox(-5.0F+0.5f, 4.0F, -2.0F, 1, 4, 4, 0.0F);
        this.leftLegPlate1 = new ModelRenderer(this, 0, 86);
        this.leftLegPlate1.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftLegPlate1.addBox(-2.5F, 1.5F, -2.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(leftLegPlate1, -0.40142572795869574F, -0.0F, 0.0F);
        this.rightArmPlate1 = new ModelRenderer(this, 0, 56);
        this.rightArmPlate1.mirror = true;
        this.rightArmPlate1.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightArmPlate1.addBox(-4.0F, -5.0F, -4.5F, 6, 3, 1, 0.0F);
        this.setRotateAngle(rightArmPlate1, -0.19198621771937624F, -0.0F, -0.9599310885968813F);
        this.leftLegPlate13 = new ModelRenderer(this, 0, 91);
        this.leftLegPlate13.setRotationPoint(0.0F, 5.0F, 0.0F);
        this.leftLegPlate13.addBox(1.0F, 1.5F, -2.5F, 1, 3, 5, 0.0F);
        this.setRotateAngle(leftLegPlate13, 0.0F, -0.0F, -0.40142572795869574F);
        this.backPlate = new ModelRenderer(this, 22, 94);
        this.backPlate.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.backPlate.addBox(-4.0F, -7.699999809265137F, 3.700000047683716F, 8, 8, 1, 0.0F);
        this.setRotateAngle(backPlate, 0.06981316953897475F, -0.0F, 0.0F);
        this.leftLegPlate8 = new ModelRenderer(this, 0, 86);
        this.leftLegPlate8.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftLegPlate8.addBox(-2.5F, 1.5F, 1.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(leftLegPlate8, 0.40142572795869574F, -0.0F, 0.0F);
        this.leftLeg = new ModelRenderer(this, 0, 70);
        this.leftLeg.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftLeg.addBox(-2.5F, 0.0F, -2.5F, 5, 10, 5, 0.0F);
        this.facePlate5 = new ModelRenderer(this, 0, 106);
        this.facePlate5.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.facePlate5.addBox(-4.0F, -4.5F, -4.5F, 8, 2, 1, 0.0F);
        this.belt = new ModelRenderer(this, 0, 61);
        this.belt.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.belt.addBox(-5.0F, 11.0F, -3.0F, 10, 2, 6, 0.0F);
        this.rightLegPlate3 = new ModelRenderer(this, 0, 86);
        this.rightLegPlate3.mirror = true;
        this.rightLegPlate3.setRotationPoint(0.0F, 5.0F, 0.0F);
        this.rightLegPlate3.addBox(-2.5F, 1.5F, -2.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(rightLegPlate3, -0.40142572795869574F, -0.0F, 0.0F);
        this.chestPlate3 = new ModelRenderer(this, 0, 52);
        this.chestPlate3.setRotationPoint(0.0F, -1.5F, 0.0F);
        this.chestPlate3.addBox(0.6000000238418579F, 2.0F, -4.5F, 5, 2, 1, 0.0F);
        this.setRotateAngle(chestPlate3, 0.3141592741012573F, -0.0F, 0.17453292012214658F);
        this.sidePlate4 = new ModelRenderer(this, 13, 110);
        this.sidePlate4.setRotationPoint(0.0F, 0.5F, 0.0F);
        this.sidePlate4.addBox(4.0F, -8.5F, -3.0F, 1, 7, 4, 0.0F);
        this.setRotateAngle(sidePlate4, 0.0F, 0.22689279913902283F, 0.0F);
        this.rightLegPlate6 = new ModelRenderer(this, 13, 90);
        this.rightLegPlate6.mirror = true;
        this.rightLegPlate6.setRotationPoint(0.0F, 2.5F, 0.0F);
        this.rightLegPlate6.addBox(-1.5F, 1.0F, -2.8F, 1, 2, 1, 0.0F);
        this.setRotateAngle(rightLegPlate6, -0.40142572795869574F, -0.0F, 0.0F);

        this.rightBoot2 = new ModelRenderer(this, 22, 73);
        this.rightBoot2.mirror = true;
        this.rightBoot2.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightBoot2.addBox(-3.0F, 8.5F, -3.0F, 5, 1, 6, 0.0F);
        this.leftLegPlate7 = new ModelRenderer(this, 13, 90);
        this.leftLegPlate7.setRotationPoint(0.0F, 5.0F, 0.0F);
        this.leftLegPlate7.addBox(0.5F, 1.0F, -2.8F, 1, 2, 1, 0.0F);
        this.setRotateAngle(leftLegPlate7, -0.40142572795869574F, -0.0F, 0.0F);
        this.facePlate6 = new ModelRenderer(this, 19, 106);
        this.facePlate6.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.facePlate6.addBox(-1.0F, -4.5F, -5.0F, 2, 2, 1, 0.0F);
        this.facePlate1 = new ModelRenderer(this, 0, 110);
        this.facePlate1.setRotationPoint(0.0F, 0.5F, 0.0F);
        this.facePlate1.addBox(-2.0F, -3.5F, -5.5F, 5, 3, 1, 0.0F);
        this.setRotateAngle(facePlate1, 0.05235987901687623F, -0.34906584024429316F, 0.0F);
        this.sidePlate1 = new ModelRenderer(this, 13, 110);
        this.sidePlate1.mirror = true;
        this.sidePlate1.setRotationPoint(0.0F, 0.5F, 0.0F);
        this.sidePlate1.addBox(-5.0F, -8.5F, -3.0F, 1, 7, 4, 0.0F);
        this.setRotateAngle(sidePlate1, 0.0F, -0.22689279913902283F, 0.0F);
        this.facePlate4 = new ModelRenderer(this, 0, 100);
        this.facePlate4.mirror = true;
        this.facePlate4.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.facePlate4.addBox(-4.0F, -7.5F, -6.5F, 5, 4, 1, 0.0F);
        this.setRotateAngle(facePlate4, -0.17453292012214658F, 0.15707963705062866F, 0.0F);
        this.rightLegPlate12 = new ModelRenderer(this, 0, 91);
        this.rightLegPlate12.mirror = true;
        this.rightLegPlate12.setRotationPoint(0.0F, 2.5F, 0.0F);
        this.rightLegPlate12.addBox(-2.0F, 1.5F, -2.5F, 1, 3, 5, 0.0F);
        this.setRotateAngle(rightLegPlate12, 0.0F, -0.0F, 0.40142572795869574F);
        this.leftArmPlate4 = new ModelRenderer(this, 0, 56);
        this.leftArmPlate4.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftArmPlate4.addBox(-2.0F, -3.0F, 3.0F, 6, 3, 1, 0.0F);
        this.setRotateAngle(leftArmPlate4, 0.19198621771937624F, -0.0F, 0.9599310885968813F);
        this.rightLegPlate4 = new ModelRenderer(this, 13, 86);
        this.rightLegPlate4.mirror = true;
        this.rightLegPlate4.setRotationPoint(0.0F, 2.5F, 0.0F);
        this.rightLegPlate4.addBox(-0.5F, 1.5F, -2.8F, 3, 2, 1, 0.0F);
        this.setRotateAngle(rightLegPlate4, -0.40142572795869574F, -0.0F, 0.0F);
        this.leftLegPlate12 = new ModelRenderer(this, 0, 91);
        this.leftLegPlate12.setRotationPoint(0.0F, 2.5F, 0.0F);
        this.leftLegPlate12.addBox(1.0F, 1.5F, -2.5F, 1, 3, 5, 0.0F);
        this.setRotateAngle(leftLegPlate12, 0.0F, -0.0F, -0.40142572795869574F);
        this.chestPlate2 = new ModelRenderer(this, 0, 52);
        this.chestPlate2.mirror = true;
        this.chestPlate2.setRotationPoint(0.0F, 0.5F, 0.0F);
        this.chestPlate2.addBox(-5.699999809265137F, 2.0F, -4.5F, 5, 2, 1, 0.0F);
        this.setRotateAngle(chestPlate2, 0.3141592741012573F, -0.0F, -0.22689279913902285F);
        this.backPlate_1 = new ModelRenderer(this, 33, 61);
        this.backPlate_1.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.backPlate_1.addBox(-2.0F, 2.0F, 2.5F, 4, 6, 1, 0.0F);
        this.topPlate = new ModelRenderer(this, 22, 84);
        this.topPlate.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.topPlate.addBox(-4.0F, -8.199999809265137F, -3.5999999046325684F, 8, 1, 8, 0.0F);
        this.setRotateAngle(topPlate, 0.05235987901687623F, -0.0F, 0.0F);
        this.rightBoot3 = new ModelRenderer(this, 45, 73);
        this.rightBoot3.mirror = true;
        this.rightBoot3.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightBoot3.addBox(-1.0F, 9.0F, -4.5F, 1, 3, 7, 0.0F);
        this.setRotateAngle(rightBoot3, 0.10471975511965977F, -0.0F, 0.2617993877991494F);
        this.leftArmSymbol = new ModelRenderer(this, 50, 45);
        this.leftArmSymbol.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftArmSymbol.addBox(4.0F-0.5f, 4.0F, -2.0F, 1, 4, 4, 0.0F);
        this.sidePlate6 = new ModelRenderer(this, 13, 110);
        this.sidePlate6.setRotationPoint(0.0F, 0.5F, 6.0F);
        this.sidePlate6.addBox(4.0F, -8.5F, -5.0F, 1, 7, 4, 0.0F);
        this.setRotateAngle(sidePlate6, 0.0F, 0.22689279913902283F, 0.0F);
        this.chestPlate5 = new ModelRenderer(this, 0, 52);
        this.chestPlate5.setRotationPoint(0.0F, -3.5F, 0.0F);
        this.chestPlate5.addBox(0.5F, 2.0F, -4.5F, 5, 2, 1, 0.0F);
        this.setRotateAngle(chestPlate5, 0.3141592741012573F, -0.0F, 0.12217304855585097F);
        this.rightLeg = new ModelRenderer(this, 0, 70);
        this.rightLeg.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightLeg.addBox(-2.5F, 0.0F, -2.5F, 5, 10, 5, 0.0F);
        this.leftArmPlate2 = new ModelRenderer(this, 0, 56);
        this.leftArmPlate2.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftArmPlate2.addBox(-2.0F, -3.0F, -4.0F, 6, 3, 1, 0.0F);
        this.setRotateAngle(leftArmPlate2, -0.19198621771937624F, -0.0F, 0.9599310885968813F);
        this.leftBoot2 = new ModelRenderer(this, 22, 73);
        this.leftBoot2.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftBoot2.addBox(-2.0F, 8.5F, -3.0F, 5, 1, 6, 0.0F);
        this.leftArmPlate3 = new ModelRenderer(this, 0, 56);
        this.leftArmPlate3.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.leftArmPlate3.addBox(-2.0F, -5.0F, 3.5F, 6, 3, 1, 0.0F);
        this.setRotateAngle(leftArmPlate3, 0.19198621771937624F, -0.0F, 0.9599310885968813F);

        this.rightLegPlate5 = new ModelRenderer(this, 13, 86);
        this.rightLegPlate5.mirror = true;
        this.rightLegPlate5.setRotationPoint(0.0F, 5.0F, 0.0F);
        this.rightLegPlate5.addBox(-0.5F, 1.5F, -2.8F, 3, 2, 1, 0.0F);
        this.setRotateAngle(rightLegPlate5, -0.40142572795869574F, -0.0F, 0.0F);
        this.sidePlate3 = new ModelRenderer(this, 13, 110);
        this.sidePlate3.mirror = true;
        this.sidePlate3.setRotationPoint(0.0F, 0.5F, 6.0F);
        this.sidePlate3.addBox(-5.0F, -8.5F, -5.0F, 1, 7, 4, 0.0F);
        this.setRotateAngle(sidePlate3, 0.0F, -0.22689279913902283F, 0.0F);
        this.chestPlate1 = new ModelRenderer(this, 0, 52);
        this.chestPlate1.setRotationPoint(0.0F, 0.5F, 0.0F);
        this.chestPlate1.addBox(0.699999988079071F, 2.0F, -4.5F, 5, 2, 1, 0.0F);
        this.setRotateAngle(chestPlate1, 0.3141592741012573F, -0.0F, 0.22689279913902285F);
        this.leftLegPlate4 = new ModelRenderer(this, 13, 86);
        this.leftLegPlate4.setRotationPoint(0.0F, 2.5F, 0.0F);
        this.leftLegPlate4.addBox(-2.5F, 1.5F, -2.8F, 3, 2, 1, 0.0F);
        this.setRotateAngle(leftLegPlate4, -0.40142572795869574F, -0.0F, 0.0F);
        this.rightBoot1 = new ModelRenderer(this, 44, 61);
        this.rightBoot1.mirror = true;
        this.rightBoot1.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightBoot1.addBox(-3.0F, 9.5F, -5.0F, 5, 3, 8, 0.0F);
        this.chestPlate4 = new ModelRenderer(this, 0, 52);
        this.chestPlate4.mirror = true;
        this.chestPlate4.setRotationPoint(0.0F, -1.5F, 0.0F);
        this.chestPlate4.addBox(-5.599999904632568F, 2.0F, -4.5F, 5, 2, 1, 0.0F);
        this.setRotateAngle(chestPlate4, 0.3141592741012573F, -0.0F, -0.17453292012214658F);
        this.rightShoulder = new ModelRenderer(this, 29, 33);
        this.rightShoulder.mirror = true;
        this.rightShoulder.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightShoulder.addBox(-5.0F, -3.0F, -3.0F, 6, 5, 6, 0.0F);
        this.rightLegPlate9 = new ModelRenderer(this, 0, 86);
        this.rightLegPlate9.mirror = true;
        this.rightLegPlate9.setRotationPoint(0.0F, 2.5F, 0.0F);
        this.rightLegPlate9.addBox(-2.5F, 1.5F, 1.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(rightLegPlate9, 0.40142572795869574F, -0.0F, 0.0F);
        this.sidePlate2 = new ModelRenderer(this, 13, 110);
        this.sidePlate2.mirror = true;
        this.sidePlate2.setRotationPoint(0.0F, 0.5F, 3.0F);
        this.sidePlate2.addBox(-5.0F, -8.5F, -4.0F, 1, 7, 4, 0.0F);
        this.setRotateAngle(sidePlate2, 0.0F, -0.22689279913902283F, 0.0F);

        this.rightArmPlate3 = new ModelRenderer(this, 0, 56);
        this.rightArmPlate3.mirror = true;
        this.rightArmPlate3.setRotationPoint(-0.0F, 0.0F, 0.0F);
        this.rightArmPlate3.addBox(-4.0F, -5.0F, 3.5F, 6, 3, 1, 0.0F);
        this.setRotateAngle(rightArmPlate3, 0.19198621771937624F, -0.0F, -0.9599310885968813F);
        this.leftLegPlate6 = new ModelRenderer(this, 13, 90);
        this.leftLegPlate6.setRotationPoint(0.0F, 2.5F, 0.0F);
        this.leftLegPlate6.addBox(0.5F, 1.0F, -2.8F, 1, 2, 1, 0.0F);
        this.setRotateAngle(leftLegPlate6, -0.40142572795869574F, -0.0F, 0.0F);
        this.rightArmPlate2 = new ModelRenderer(this, 0, 56);
        this.rightArmPlate2.mirror = true;
        this.rightArmPlate2.setRotationPoint(0.0F, 0.0F, 0.0F);
        this.rightArmPlate2.addBox(-4.0F, -3.0F, -4.0F, 6, 3, 1, 0.0F);
        this.setRotateAngle(rightArmPlate2, -0.19198621771937624F, -0.0F, -0.9599310885968813F);
        this.leftLegPlate10 = new ModelRenderer(this, 0, 86);
        this.leftLegPlate10.setRotationPoint(0.0F, 5.0F, 0.0F);
        this.leftLegPlate10.addBox(-2.5F, 1.5F, 1.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(leftLegPlate10, 0.40142572795869574F, -0.0F, 0.0F);
        this.leftLegPlate2 = new ModelRenderer(this, 0, 86);
        this.leftLegPlate2.setRotationPoint(0.0F, 2.5F, 0.0F);
        this.leftLegPlate2.addBox(-2.5F, 1.5F, -2.3F, 5, 3, 1, 0.0F);
        this.setRotateAngle(leftLegPlate2, -0.40142572795869574F, -0.0F, 0.0F);
        
        this.bipedBody.cubeList.clear();
        this.bipedHead.cubeList.clear();
        this.bipedHeadwear.cubeList.clear();
        this.bipedLeftArm.cubeList.clear();
        this.bipedLeftLeg.cubeList.clear();
        this.bipedRightArm.cubeList.clear();
        this.bipedRightLeg.cubeList.clear();
        
        if(addChestPiece)
        {
            this.bipedLeftArm.addChild(this.leftShoulder);
            this.bipedLeftArm.addChild(this.leftArm);
            this.bipedLeftArm.addChild(this.leftArmPlate1);
            this.bipedBody.addChild(this.chestPlate6);
            this.bipedHead.addChild(this.sidePlate5);
            this.bipedBody.addChild(this.chestMain);
            this.bipedRightArm.addChild(this.rightArm);
            this.bipedRightArm.addChild(this.rightArmPlate4);
            this.bipedRightArm.addChild(this.rightArmSymbol);
            this.bipedRightArm.addChild(this.rightArmPlate1);
            this.bipedBody.addChild(this.chestPlate3);
            this.bipedLeftArm.addChild(this.leftArmPlate4);
            this.bipedBody.addChild(this.chestPlate2);
            this.bipedBody.addChild(this.backPlate_1);
            this.bipedLeftArm.addChild(this.leftArmSymbol);
            this.bipedBody.addChild(this.chestPlate5);
            this.bipedLeftArm.addChild(this.leftArmPlate2);
            this.bipedLeftArm.addChild(this.leftArmPlate3);
            this.bipedBody.addChild(this.chestPlate1);
            this.bipedBody.addChild(this.chestPlate4);
            this.bipedRightArm.addChild(this.rightShoulder);
            this.bipedRightArm.addChild(this.rightArmPlate3);
            this.bipedRightArm.addChild(this.rightArmPlate2);
        }
        
        if(addLeggings)
        {
            this.bipedLeftLeg.addChild(this.leftLegPlate9);
            this.bipedLeftLeg.addChild(this.leftLegPlate11);
            this.bipedLeftLeg.addChild(this.leftLegPlate5);
            this.bipedRightLeg.addChild(this.rightLegPlate13);
            this.bipedRightLeg.addChild(this.rightLegPlate2);
            this.bipedRightLeg.addChild(this.rightLegPlate8);
            this.bipedRightLeg.addChild(this.rightLegPlate1);
            this.bipedRightLeg.addChild(this.rightLegPlate7);
            this.bipedRightLeg.addChild(this.rightLegPlate11);
            this.bipedLeftLeg.addChild(this.leftLegPlate3);
            this.bipedRightLeg.addChild(this.rightLegPlate10);
            this.bipedLeftLeg.addChild(this.leftLegPlate1);
            this.bipedLeftLeg.addChild(this.leftLegPlate13);
            this.bipedLeftLeg.addChild(this.leftLegPlate8);
            this.bipedLeftLeg.addChild(this.leftLeg);
            this.bipedBody.addChild(this.belt);
            this.bipedRightLeg.addChild(this.rightLegPlate3);
            this.bipedRightLeg.addChild(this.rightLegPlate6);
            this.bipedLeftLeg.addChild(this.leftLegPlate7);
            this.bipedRightLeg.addChild(this.rightLegPlate12);
            this.bipedRightLeg.addChild(this.rightLegPlate4);
            this.bipedLeftLeg.addChild(this.leftLegPlate12);
            this.bipedRightLeg.addChild(this.rightLeg);
            this.bipedRightLeg.addChild(this.rightLegPlate5);
            this.bipedLeftLeg.addChild(this.leftLegPlate4);
            this.bipedLeftLeg.addChild(this.leftLegPlate2);
            this.bipedLeftLeg.addChild(this.leftLegPlate10);
            this.bipedLeftLeg.addChild(this.leftLegPlate6);
            this.bipedRightLeg.addChild(this.rightLegPlate9);
        }
        
        if(addBoots)
        {
            this.bipedLeftLeg.addChild(this.leftBoot1);
            this.bipedLeftLeg.addChild(this.leftBoot3);
            this.bipedRightLeg.addChild(this.rightBoot2);
            this.bipedLeftLeg.addChild(this.leftBoot2);
            this.bipedRightLeg.addChild(this.rightBoot1);
            this.bipedRightLeg.addChild(this.rightBoot3);
        }
        
        if(addHelmet)
        {
            this.bipedHead.addChild(this.facePlate3);
            this.bipedHead.addChild(this.facePlate2);
            this.bipedHead.addChild(this.backPlate);
            this.bipedHead.addChild(this.facePlate5);
            this.bipedHead.addChild(this.sidePlate4);
            this.bipedHead.addChild(this.facePlate6);
            this.bipedHead.addChild(this.facePlate1);
            this.bipedHead.addChild(this.sidePlate1);
            this.bipedHead.addChild(this.facePlate4);
            this.bipedHead.addChild(this.topPlate);
            this.bipedHead.addChild(this.sidePlate6);
            this.bipedHead.addChild(this.sidePlate3);
            this.bipedHead.addChild(this.sidePlate2);
        }
    }

    @Override
    public void render(Entity entity, float f, float f1, float f2, float f3, float f4, float f5) 
    {
    	setRotationAngles(f, f1, f2, f3, f4, f5, entity);
        this.bipedLeftArm.render(f5);
        this.bipedRightArm.render(f5);
        this.bipedLeftLeg.render(f5);
        this.bipedHead.render(f5);
        this.bipedRightLeg.render(f5);
        this.bipedBody.render(f5);
    }

    /**
     * This is a helper function from Tabula to set the rotation of model parts
     */
    public void setRotateAngle(ModelRenderer modelRenderer, float x, float y, float z) {
        modelRenderer.rotateAngleX = x;
        modelRenderer.rotateAngleY = y;
        modelRenderer.rotateAngleZ = z;
    }
}